"use strict";
const Version = require("../../joynr/types/Version");
const DiscoveryError = require("../../joynr/types/DiscoveryError");
const CustomParameter = require("../../joynr/types/CustomParameter");
const DiscoveryScope = require("../../joynr/types/DiscoveryScope");
const DiscoveryQos = require("../../joynr/types/DiscoveryQos");
const DiscoveryEntryWithMetaInfo = require("../../joynr/types/DiscoveryEntryWithMetaInfo");
const DiscoveryEntry = require("../../joynr/types/DiscoveryEntry");
const ProviderQos = require("../../joynr/types/ProviderQos");
const ProviderScope = require("../../joynr/types/ProviderScope");
const ProviderOperation = require("../../../joynr/provider/ProviderOperation");
const JoynrProvider_1 = require("../../../joynr/types/JoynrProvider");
/**
 * PLEASE NOTE. THIS IS A GENERATED FILE!
 * <br/>Generation date: Tue Feb 06 14:18:41 CET 2024
 * <br/><br/>The <code>Discovery</code> interface is a joynr internal
 * interface. This interface is used by libjoynr to add, lookup or
 * remove provider to joynr discovery. Internally joynr discovery
 * consists of a centralized discovery directory
 * (<code>GlobalCapabilitiesDirectory</code>) that is distributed to
 * all cluster controller (<code>LocalCapabilitiesDirectory</code>).
 * #noVersionGeneration
 */
class DiscoveryProvider extends JoynrProvider_1.JoynrProvider {
    /**
     * @param [implementation] the implementation of the provider
     * @param [implementation.ATTRIBUTENAME] the definition of attribute implementation
     * @param [implementation.ATTRIBUTENAME.set] the getter function that stores the given attribute value
     * @param [implementation.ATTRIBUTENAME.get] the getter function that returns the current attribute value
     * @param [implementation.OPERATIONNAME] the operation function
     * @param [implementation.EVENTNAME] the definition of the event implementation
     */
    constructor(implementation) {
        super();
        this.interfaceName = "system/Discovery";
        // defining provider members
        this.add = new ProviderOperation(implementation.add, "add", [
            {
                inputParameter: [
                    {
                        name: "discoveryEntry",
                        type: "joynr.types.DiscoveryEntry"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "discoveryEntry",
                        type: "joynr.types.DiscoveryEntry"
                    },
                    {
                        name: "awaitGlobalRegistration",
                        type: "Boolean"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "discoveryEntry",
                        type: "joynr.types.DiscoveryEntry"
                    },
                    {
                        name: "awaitGlobalRegistration",
                        type: "Boolean"
                    },
                    {
                        name: "gbids",
                        type: "String[]"
                    }
                ],
                error: {
                    type: "joynr.types.DiscoveryError"
                },
                outputParameter: []
            }
        ]);
        this.lookup = new ProviderOperation(implementation.lookup, "lookup", [
            {
                inputParameter: [
                    {
                        name: "domains",
                        type: "String[]"
                    },
                    {
                        name: "interfaceName",
                        type: "String"
                    },
                    {
                        name: "discoveryQos",
                        type: "joynr.types.DiscoveryQos"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: [
                    {
                        name: "result",
                        type: "joynr.types.DiscoveryEntryWithMetaInfo[]"
                    }
                ]
            },
            {
                inputParameter: [
                    {
                        name: "domains",
                        type: "String[]"
                    },
                    {
                        name: "interfaceName",
                        type: "String"
                    },
                    {
                        name: "discoveryQos",
                        type: "joynr.types.DiscoveryQos"
                    },
                    {
                        name: "gbids",
                        type: "String[]"
                    }
                ],
                error: {
                    type: "joynr.types.DiscoveryError"
                },
                outputParameter: [
                    {
                        name: "result",
                        type: "joynr.types.DiscoveryEntryWithMetaInfo[]"
                    }
                ]
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: [
                    {
                        name: "result",
                        type: "joynr.types.DiscoveryEntryWithMetaInfo"
                    }
                ]
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "discoveryQos",
                        type: "joynr.types.DiscoveryQos"
                    },
                    {
                        name: "gbids",
                        type: "String[]"
                    }
                ],
                error: {
                    type: "joynr.types.DiscoveryError"
                },
                outputParameter: [
                    {
                        name: "result",
                        type: "joynr.types.DiscoveryEntryWithMetaInfo"
                    }
                ]
            }
        ]);
        this.addToAll = new ProviderOperation(implementation.addToAll, "addToAll", [
            {
                inputParameter: [
                    {
                        name: "discoveryEntry",
                        type: "joynr.types.DiscoveryEntry"
                    },
                    {
                        name: "awaitGlobalRegistration",
                        type: "Boolean"
                    }
                ],
                error: {
                    type: "joynr.types.DiscoveryError"
                },
                outputParameter: []
            }
        ]);
        this.remove = new ProviderOperation(implementation.remove, "remove", [
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            }
        ]);
    }
    static getUsedJoynrtypes() {
        return [
            Version,
            DiscoveryError,
            CustomParameter,
            DiscoveryScope,
            DiscoveryQos,
            DiscoveryEntryWithMetaInfo,
            DiscoveryEntry,
            ProviderQos,
            ProviderScope
        ];
    }
}
/**
 * The MAJOR_VERSION of the provider is GENERATED FROM THE INTERFACE DESCRIPTION
 */
DiscoveryProvider.MAJOR_VERSION = 0;
/**
 * The MINOR_VERSION of the provider is GENERATED FROM THE INTERFACE DESCRIPTION
 */
DiscoveryProvider.MINOR_VERSION = 3;
module.exports = DiscoveryProvider;
